diff -aupr u-boot-2018.01-rc3/include/configs/rpi.h u-boot-2018.01-rc3.koh/include/configs/rpi.h
--- u-boot-2018.01-rc3/include/configs/rpi.h	2018-01-02 01:46:43.000000000 +0100
+++ u-boot-2018.01-rc3.koh/include/configs/rpi.h	2018-01-07 21:05:17.299089000 +0100
@@ -76,11 +76,14 @@
 #endif
 
 /* Console UART */
+#if 0
 #if defined (CONFIG_BCM2837) || defined(CONFIG_TARGET_RPI_0_W)
 #define CONFIG_BCM283X_MU_SERIAL
 #else
 #define CONFIG_PL01X_SERIAL
 #endif
+#endif
+#define CONFIG_PL01X_SERIAL
 
 /* Console configuration */
 #define CONFIG_SYS_CBSIZE		1024
diff -aupr u-boot-2018.01-rc3/lib/efi_loader/efi_console.c u-boot-2018.01-rc3.koh/lib/efi_loader/efi_console.c
--- u-boot-2018.01-rc3/lib/efi_loader/efi_console.c	2018-01-02 01:46:43.000000000 +0100
+++ u-boot-2018.01-rc3.koh/lib/efi_loader/efi_console.c	2018-01-08 15:46:53.080349000 +0100
@@ -13,6 +13,9 @@
 #include <stdio_dev.h>
 #include <video_console.h>
 
+extern u64 ticks_timer_cons;
+extern u64 calls_timer_cons;
+
 static bool console_size_queried;
 
 #define EFI_COUT_MODE_2 2
@@ -485,12 +488,15 @@ static void EFIAPI efi_key_notify(struct
 static void EFIAPI efi_console_timer_notify(struct efi_event *event,
 					    void *context)
 {
+	u64 ticks = get_ticks();
+	++calls_timer_cons;
 	EFI_ENTRY("%p, %p", event, context);
 	if (tstc()) {
 		efi_con_in.wait_for_key->is_signaled = true;
 		efi_signal_event(efi_con_in.wait_for_key);
 		}
 	EFI_EXIT(EFI_SUCCESS);
+	ticks_timer_cons += get_ticks() - ticks;
 }
 
 
@@ -539,8 +545,13 @@ int efi_console_register(void)
 		printf("ERROR: Failed to register console event\n");
 		return r;
 	}
+#if 0
 	/* 5000 ns cycle is sufficient for 2 MBaud */
 	r = efi_set_timer(console_timer_event, EFI_TIMER_PERIODIC, 50);
+#else
+	/* 100 ms */
+	r = efi_set_timer(console_timer_event, EFI_TIMER_PERIODIC, 100*1000*10);
+#endif
 	if (r != EFI_SUCCESS)
 		printf("ERROR: Failed to set console timer\n");
 	return r;
diff -aupr u-boot-2018.01-rc3/lib/efi_loader/efi_net.c u-boot-2018.01-rc3.koh/lib/efi_loader/efi_net.c
--- u-boot-2018.01-rc3/lib/efi_loader/efi_net.c	2018-01-02 01:46:43.000000000 +0100
+++ u-boot-2018.01-rc3.koh/lib/efi_loader/efi_net.c	2018-01-08 15:54:42.879896000 +0100
@@ -6,6 +6,10 @@
  *  SPDX-License-Identifier:     GPL-2.0+
  */
 
+#define DBG1(x)
+#define DBG2(x)
+#define DBG3(x)
+
 #include <common.h>
 #include <efi_loader.h>
 #include <inttypes.h>
@@ -14,6 +18,14 @@
 
 DECLARE_GLOBAL_DATA_PTR;
 
+static void efi_net_push(void *pkt, int len);
+u64 ticks_timer_net = 0;
+u64 calls_timer_net = 0;
+u64 ticks_timer_cons = 0;
+u64 calls_timer_cons = 0;
+static char prof_print_pending = 0;
+static struct efi_event *profile_timer_event;
+
 static const efi_guid_t efi_net_guid = EFI_SIMPLE_NETWORK_GUID;
 static const efi_guid_t efi_pxe_guid = EFI_PXE_GUID;
 static struct efi_pxe_packet *dhcp_ack;
@@ -43,6 +55,7 @@ struct efi_net_obj {
 static efi_status_t EFIAPI efi_net_start(struct efi_simple_network *this)
 {
 	EFI_ENTRY("%p", this);
+	DBG1(printf("%s: \n", __func__));
 
 	return EFI_EXIT(EFI_SUCCESS);
 }
@@ -50,6 +63,7 @@ static efi_status_t EFIAPI efi_net_start
 static efi_status_t EFIAPI efi_net_stop(struct efi_simple_network *this)
 {
 	EFI_ENTRY("%p", this);
+	DBG1(printf("%s: \n", __func__));
 
 	return EFI_EXIT(EFI_SUCCESS);
 }
@@ -57,10 +71,21 @@ static efi_status_t EFIAPI efi_net_stop(
 static efi_status_t EFIAPI efi_net_initialize(struct efi_simple_network *this,
 					      ulong extra_rx, ulong extra_tx)
 {
+	u64 ticks1, ticks2;
+	int i;
+
 	EFI_ENTRY("%p, %lx, %lx", this, extra_rx, extra_tx);
+	DBG1(printf("%s: \n", __func__));
 
 	eth_init();
 
+	for (i = 0; i < 20; i++) {
+		ticks1 = get_ticks();
+		udelay(1000);
+		ticks2 = get_ticks();
+		DBG1(printf("ticks/ms: %llu\n", ticks2-ticks1));
+	}
+
 	return EFI_EXIT(EFI_SUCCESS);
 }
 
@@ -68,6 +93,7 @@ static efi_status_t EFIAPI efi_net_reset
 					 int extended_verification)
 {
 	EFI_ENTRY("%p, %x", this, extended_verification);
+	DBG1(printf("%s: \n", __func__));
 
 	return EFI_EXIT(EFI_SUCCESS);
 }
@@ -75,6 +101,7 @@ static efi_status_t EFIAPI efi_net_reset
 static efi_status_t EFIAPI efi_net_shutdown(struct efi_simple_network *this)
 {
 	EFI_ENTRY("%p", this);
+	DBG1(printf("%s: \n", __func__));
 
 	return EFI_EXIT(EFI_SUCCESS);
 }
@@ -87,7 +114,12 @@ static efi_status_t EFIAPI efi_net_recei
 	EFI_ENTRY("%p, %x, %x, %x, %lx, %p", this, enable, disable,
 		  reset_mcast_filter, mcast_filter_count, mcast_filter);
 
+#if 0
 	return EFI_EXIT(EFI_UNSUPPORTED);
+#else
+	printf("%s: WARNING - unsupported but returning success\n", __func__);
+	return EFI_EXIT(EFI_SUCCESS);
+#endif
 }
 
 static efi_status_t EFIAPI efi_net_station_address(
@@ -131,9 +163,19 @@ static efi_status_t EFIAPI efi_net_nvdat
 static efi_status_t EFIAPI efi_net_get_status(struct efi_simple_network *this,
 					      u32 *int_status, void **txbuf)
 {
+	u64 ticks3, ticks2, ticks1 = get_ticks();
 	EFI_ENTRY("%p, %p, %p", this, int_status, txbuf);
 
 	efi_timer_check();
+	ticks2 = get_ticks();
+
+#if 0
+        if (!new_rx_packet) {
+                push_packet = efi_net_push;
+                eth_rx();
+                push_packet = NULL;
+        }
+#endif
 
 	if (int_status) {
 		/* We send packets synchronously, so nothing is outstanding */
@@ -146,6 +188,15 @@ static efi_status_t EFIAPI efi_net_get_s
 
 	new_tx_packet = NULL;
 
+	ticks3 = get_ticks();
+	DBG3(printf("%20s: cur=%llu tot=%llu tim=%llu\n", __func__, ticks3, ticks3-ticks1, ticks2-ticks1));
+
+	if (prof_print_pending != 0) {
+		DBG2(printf("prof: net=%llu/%llu cons=%llu/%llu\n",
+		    calls_timer_net, ticks_timer_net, calls_timer_cons, ticks_timer_cons));
+		prof_print_pending = 0;
+	}
+
 	return EFI_EXIT(EFI_SUCCESS);
 }
 
@@ -154,11 +205,20 @@ static efi_status_t EFIAPI efi_net_trans
 		struct efi_mac_address *src_addr,
 		struct efi_mac_address *dest_addr, u16 *protocol)
 {
+	u64 ticks3, ticks2, ticks1 = get_ticks();
 	EFI_ENTRY("%p, %lu, %lu, %p, %p, %p, %p", this,
 		  (unsigned long)header_size, (unsigned long)buffer_size,
 		  buffer, src_addr, dest_addr, protocol);
 
 	efi_timer_check();
+	ticks2 = get_ticks();
+#if 0
+        if (!new_rx_packet) {
+                push_packet = efi_net_push;
+                eth_rx();
+                push_packet = NULL;
+        }
+#endif
 
 	if (header_size) {
 		/* We would need to create the header if header_size != 0 */
@@ -175,6 +235,9 @@ static efi_status_t EFIAPI efi_net_trans
 
 	new_tx_packet = buffer;
 
+	ticks3 = get_ticks();
+	DBG3(printf("%20s: cur=%llu tot=%llu tim=%llu\n", __func__, ticks3, ticks3-ticks1, ticks2-ticks1));
+
 	return EFI_EXIT(EFI_SUCCESS);
 }
 
@@ -204,6 +267,7 @@ static efi_status_t EFIAPI efi_net_recei
 		struct efi_mac_address *src_addr,
 		struct efi_mac_address *dest_addr, u16 *protocol)
 {
+	u64 ticks3, ticks2, ticks1 = get_ticks();
 	struct ethernet_hdr *eth_hdr;
 	size_t hdr_size = sizeof(struct ethernet_hdr);
 	u16 protlen;
@@ -212,6 +276,14 @@ static efi_status_t EFIAPI efi_net_recei
 		  buffer_size, buffer, src_addr, dest_addr, protocol);
 
 	efi_timer_check();
+	ticks2 = get_ticks();
+#if 0
+        if (!new_rx_packet) {
+                push_packet = efi_net_push;
+                eth_rx();
+                push_packet = NULL;
+        }
+#endif
 
 	if (!new_rx_packet)
 		return EFI_EXIT(EFI_NOT_READY);
@@ -245,6 +317,9 @@ static efi_status_t EFIAPI efi_net_recei
 	*buffer_size = net_rx_packet_len;
 	new_rx_packet = false;
 
+	ticks3 = get_ticks();
+	DBG3(printf("%20s: cur=%llu tot=%llu tim=%llu\n", __func__, ticks3, ticks3-ticks1, ticks2-ticks1));
+
 	return EFI_EXIT(EFI_SUCCESS);
 }
 
@@ -269,6 +344,8 @@ void efi_net_set_dhcp_ack(void *pkt, int
 static void EFIAPI efi_network_timer_notify(struct efi_event *event,
 					    void *context)
 {
+	u64 ticks = get_ticks();
+	++calls_timer_net;
 	EFI_ENTRY("%p, %p", event, context);
 
 	if (!new_rx_packet) {
@@ -277,6 +354,13 @@ static void EFIAPI efi_network_timer_not
 		push_packet = NULL;
 	}
 	EFI_EXIT(EFI_SUCCESS);
+	ticks_timer_net += get_ticks() - ticks;
+}
+
+static void EFIAPI efi_profile_timer_notify(struct efi_event *event, void *context)
+{
+
+	prof_print_pending = 1;
 }
 
 /* This gets called from do_bootefi_exec(). */
@@ -366,6 +450,19 @@ int efi_net_register(void)
 		return r;
 	}
 
+	r = efi_create_event(EVT_TIMER | EVT_NOTIFY_SIGNAL, TPL_CALLBACK,
+			     efi_profile_timer_notify, NULL,
+			     &profile_timer_event);
+	if (r != EFI_SUCCESS) {
+		printf("ERROR: Failed to register profile event\n");
+		return r;
+	}
+	r = efi_set_timer(profile_timer_event, EFI_TIMER_PERIODIC, 5*1000*1000*10);
+	if (r != EFI_SUCCESS) {
+		printf("ERROR: Failed to set profile timer\n");
+		return r;
+	}
+
 	return 0;
 out_of_memory:
 	printf("ERROR: Out of memory\n");
